# Numerics
Code illustrations for chapter 9, Numerics in Stroustrup's
"A tour of C++".

# What is it?
1. `complex.cpp`: illustration using complex numbers and `valarray`.
1. `julia.cpp`: more interesting example of complex number arithmetic.
1. `plot_julia.plt`: gnuplot script to plot the Julia set.
1. `limits.cpp`: illustrates limits for integer and floating point types,
    as well as test for infinity and NaN.
1. `random.cpp`: example of generating a seed using a random device, to
    create an engine for the distribution of interest.
1. `multiple_distr.cpp`: shows how to bind an engine to multiple
    distributions using a reference wrapper.
1. `Makefile`: make file to build the code.
