# CPlusPlus
This is some sample code written in C++, with no or little bearing on
non-standard libraries.  It is mainly intended to illustrate some
programming concepts and idiosyncracies particular to C++.

## What is it?
1. `scientific_cpp.pptx`: Powerpoint presentation, introducing C++
    from the perspective of scientific computing, based on
    Bjarne Stroustrup's "A tour of C++", Addison Wesley, 2014.
1. `Basics`: illustration of basic C++ features for the presentation.
1. `UserDefinedTypes`: illustrations of user diefined types in C++ for
    the presentation.
1. `Modularity`: illustrations of modularity in C++ for the
    presentation.
1. `Classes`: illustration of classes in C++ for the presentation.
1. `Templates`: illustration of templates in C++ for the presentation.
1. `Regexes`: illustrations of strings and regular expressions in C++
    for the presentation.
1. `IoStreams`: illustration of templates in C++ for the presentation.
1. `Containers`: illustration of containers in C++ for the presentation.
1. `Algorithms`: illustration of classes in C++ for the presentation.
1. `Numerics`: illustration of doing numerical computations in C++, based
    on Bjarne Stroustrup's "A tour of C++", chapter 12.
1. `Random`: some illustrations of using the pseudorandom generator in
    standard C++.
1. `STL`: some illustrations of using the STL library.
1. `Pointers`: illustration of pointer usage in C++.
1. `Armadillo`: some illustrations of using the Armadillo linear algebra
    library.
1. `Boost`: some illustrations of using the Boost C++ library,
    mostly in the context of numerical programming.
