# Strings and regular expressions
Code illustrations for chapter 7, String and regular expressions
in Stroustrup's "A tour of C++".

# What is it?
1. `strings.cpp`: illustration of some basic string methods.
1. `processes.cpp`: illustration of using regular expressions with
    capturing, and date-time conversion.
1. `data.txt`: data file to use with `processes.cpp` containing log
    information.
1. `reformat_events.cpp`: illustrates replacing using regular
    expressions and capturing.
1. `simple_re_replace.cpp`: simple illustration of replacing using regular
    expressions and capturing.
1. `case.cpp`: illustration of `regex_match`, and case sensitive versus
    insensitive search.
1. `word_counter.cpp`: illustration of using a regular expression iterator
    to tokenize a text and count the words occurring in it.
1. `text.txt`: sample text to count words in.
1. `Makefile`: make file to build the applications.
