# Cython
Examples of how to use Cython and its impact on performance.

## What is it?
1. `cython.pptx`: Powerpoint presentation on Cython.
1. `HellowWorld`: simplest possible code to illustrate the build process.
1. `Numpy`: example of how to access numpy arrays from Cython.
1. `Exceptions`: exception handling in Cython code.
1. `JuliaSet`: compute the Julia set using a pure Python implementation,
    a Cython implementation, and a combination of Cython + OpenMP.
1. `Pi`: quadrature computation of pi implemented in Cython + OpenMP,
    illustrating automatic inferrence of reduction.
1. `Pointers`: simple example of using pointers in Cython.
1. `Primes`: motivating example shown in the slides.
1. `Profiling`: example of how to profile Cython code.
1. `Structures`: simple example of using structures in Cython and Python.
