# Matplotlib
Matplotlib is the de facto standard to create scientific plots when using
Python.


## What is it?
1. `animation.py`: illustration of how to do animations with matplotlib,
    and convert them to a movie (e.g., WMA).
1. `distribution_plot.py`: takes a file as input and plots the values as a
   histogram.  Optionally, it can superimpose a specified theoretical
   distribution as well.
1. `function_plot.py`: plots the amplitude of an ideal, damped pendulum.
   It illustrates how to plot multiple curves on the same plot, how to set
   axis labels, a title, and arbitrary annotation.
1. `heatmap_plot.py`: illustrates how to plot a heatmap.
1. `ising.py`: alternative way of creating a GIF movie for the Ising model
    describing the paramagnetic/ferromagnetic phase transition in the mean
    field approximation.
1. `surface_plot.py`: illustrates how to plot 3D surface plots.
